% Check for Regular Minimality or Maximality
% by Wasin Rujikietgumjorn 
% 02/17/05

function [M, data,violate,T] = checkRegular(M, maximal, minimal)
Mnew = M ;

violate = 0 ;
T = '' ;

% minimal = 1 ;
% maximal = 0 ;

if maximal == 1
    for i = 1:size(M,1)
        indexr = find(M(i,:) == max(M(i,:))) ;
        if length(indexr) ~= 1
            violate = 1 ;
            T = {sprintf('\nRegular Maximality is violated');
                 sprintf('There is more than one maximum value in row # %d',i);} ;
            break ;
        end
        indexc = find(M(:,indexr) == max(M(:,indexr))) ;
        if length(indexc) ~= 1
            violate = 1 ;
            T = {sprintf('\nRegular Maximality is violated');
                 sprintf('There is more than one maximum value in column # %d',indexr);} ;
            break ;
        end
        if i ~= indexc
            violate = 1 ;
            T = {sprintf('\nRegular Maximality is violated');
                 sprintf('See the maxima in row # %d and column # %d',i,indexr);} ;
            break ;
        end
        shuffle(i,1:2) = [i indexr] ;
    end
elseif minimal == 1
    for i = 1:size(M,1)
        indexr = find(M(i,:) == min(M(i,:))) ;
        if length(indexr) ~= 1
            i;
            violate = 1 ;
            T = {sprintf('\nRegular Minimality is violated');
                 sprintf('There is more than one minimum value in row # %d',i);} ;
            break ;
        end
        indexc = find(M(:,indexr) == min(M(:,indexr))) ;
        if length(indexc) ~= 1
            T = {sprintf('\nRegular Minimality is violated');
                 sprintf('There is more than one minimum value in column # %d',indexr);} ;
            i;
            violate = 1 ;
            break ;
        end
        if i ~= indexc
            T = {sprintf('\nRegular Minimality is violated');
                 sprintf('See the minima in row # %d and column # %d',i,indexr);} ;
            i;
            violate = 1 ;
            break ;
        end
        shuffle(i,1:2) = [i indexr] ;
    end
end

if violate ~= 1
    for i = 1:size(shuffle,1)
        Mnew(:,shuffle(i,1)) = M(:,shuffle(i,2)) ;     
    end
    M = Mnew ;    
end
if violate ~= 1
    for i = 1:size(shuffle,1)
        data(i,1) = shuffle(i,1) ;      % picked row
        data(i,2) = shuffle(i,2) ;      % picked column
        if mod(i,26) == 0
            data(i,3) = 90 ;        % letter in ascii, A,B,C,...
            data(i,4) = ceil(i/26) ;    % number 1,2... then col 3 and 4 can combine to A1, B1 ...
        else
            data(i,3) = mod(i,26)+64 ;
            data(i,4) = ceil(i/26) ;
        end
    end
    data ;
else
%     data = '' ;
    data = [] ;
end