%%% create tables: S_vs_G, MDS, KMEAN, HCA
%%% for options : max, mean, or normal

% S vs G
S_vs_G_Table = cell(length(St)+6,2);
S_vs_G_Table(1,1) = {'max(S)='};
S_vs_G_Table(1,2) = num2cell(max(St));
S_vs_G_Table(2,1) = {'max(G)='};
S_vs_G_Table(2,2) = num2cell(max(Gt));
S_vs_G_Table(3,1) = {'Correlation ='};
S_vs_G_Table(3,2) = num2cell(corr(St',Gt'));
S_vs_G_Table(4,1) = {'C='};
S_vs_G_Table(4,2) = num2cell(2*sum((St-Gt).^2)/(sum(St.^2)+sum(Gt.^2)));
S_vs_G_Table(6,:) = {'S','G'};
S_vs_G_Table(7:end,1) = num2cell(St);
S_vs_G_Table(7:end,2) = num2cell(Gt);

% MDS
MDS_Table = {};
if flagmds == 1

    maxtotaldim = max([(dimmdsto-dimmdsfrom+1) (dimmds2to-dimmds2from+1)]);
    MDS_Table = cell((size(Gmds,1)+3)*maxtotaldim+4,dimmdsto+dimmds2to+3);
    MDS_Table{1,1} = 'MDS Solution : Fechnerian';
    MDS_Table{1,end-dimmds2to} = 'MDS Solution : S-Index';
    MDS_Table{3,1} = 'Stress';
    MDS_Table{3,end-dimmds2to} = 'Stress';
    nr = size(Gmds,1);
    cnt = 1;    % for Fechnerian results
    for i = dimmdsfrom:dimmdsto
        MDS_Table{2,1+i} = ['Dim.' num2str(i)];
        MDS_Table{3,1+i} = stressall(i-dimmdsfrom+1);

        MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+5,1) = {['Dimension ' num2str(i)]};
        MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+6,1) = {'Pt.Id'};
        MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+7:(nr+3)*((i-dimmdsfrom+1)-1)+6+nr,1) = ptid;
        for j = 1:i
            MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+6,1+j) = {['Dim.' num2str(j)]};
            MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+7:(nr+3)*((i-dimmdsfrom+1)-1)+6+nr,1+j) = num2cell(Gmdsall(:,cnt));
            cnt = cnt+1;
        end
    end

    cnt = 1;    % for S-index results
    for i = dimmds2from:dimmds2to
        MDS_Table{2,3+dimmdsto+i} = ['Dim.' num2str(i)];
        MDS_Table{3,3+dimmdsto+i} = stressall2(i-dimmds2from+1);

        MDS_Table((nr+3)*((i-dimmds2from+1)-1)+5,end-dimmds2to) = {['Dimension ' num2str(i)]};
        MDS_Table((nr+3)*((i-dimmds2from+1)-1)+6,end-dimmds2to) = {'Pt.Id'};
        MDS_Table((nr+3)*((i-dimmds2from+1)-1)+7:(nr+3)*((i-dimmds2from+1)-1)+6+nr,end-dimmds2to) = ptid;
        for j = 1:i
            MDS_Table((nr+3)*((i-dimmds2from+1)-1)+6,end-dimmds2to+j) = {['Dim.' num2str(j)]};
            MDS_Table((nr+3)*((i-dimmds2from+1)-1)+7:(nr+3)*((i-dimmds2from+1)-1)+6+nr,end-dimmds2to+j) = num2cell(Smdsall(:,cnt));
            cnt = cnt+1;
        end
    end

end

% KMEANS
KMEANS_Table = {};
if flagkm == 1 && flagmds == 1
    KMEANS_Table = cell(size(Idkm,1)+2,5);
    KMEANS_Table(1,[1 4]) = {'Fechnerian','S-Index'};
    KMEANS_Table(2,[1 2 4 5]) = {'Object','Cluster Index','Object','Cluster Index'};
    KMEANS_Table(3:end,1) = ptid;
    KMEANS_Table(3:end,4) = ptid;
    KMEANS_Table(3:end,2) = num2cell(Idkm);
    KMEANS_Table(3:end,5) = num2cell(Idkms);
end

% HCA
HCA_Table = {};
if flaghc == 1
    HCA_Table = cell(size(Ghc,1)+4,15);
    HCA_Table(1,[1 8]) = {'Fechnerian','S-Index'};
    HCA_Table(2,[1 2 9 10]) = {'Cophenetic Correlation Coefficient',num2str(c),'Cophenetic Correlation Coefficient',num2str(Sc)};
    HCA_Table(4,[1 2 4 9 10 12]) = {'Object','Cluster Index','Inconsistent Function','Object','Cluster Index','Inconsistent Function'};
    HCA_Table(5:end,2) = num2cell(Ghc);
    HCA_Table(5:end,10) = num2cell(Shc);
    HCA_Table(5:end-1,4:7) = num2cell(I);
    HCA_Table(5:end-1,12:end) = num2cell(SI);
    HCA_Table(5:end,1) = ptid;
    HCA_Table(5:end,9) = ptid;
end