%%% create tables: S_vs_G, MDS, KMEAN, HCA
%%% for option : both

% S vs G
S_vs_G_Table = cell(length(St)+8,3);
S_vs_G_Table(1,1) = {'max(S)='};
S_vs_G_Table(1,2) = num2cell(max(St));
S_vs_G_Table(2,1) = {'max(G1)='};
S_vs_G_Table(2,2) = num2cell(max(Gt));
S_vs_G_Table(3,1) = {'max(G2)='};
S_vs_G_Table(3,2) = num2cell(max(GtFech2));
S_vs_G_Table(4,1) = {'Correlation (S,G1) ='};
S_vs_G_Table(4,2) = num2cell(corr(St',Gt'));
S_vs_G_Table(5,1) = {'Correlation (S,G2) ='};
S_vs_G_Table(5,2) = num2cell(corr(St',GtFech2'));
S_vs_G_Table(6,1) = {'C (S,G1) ='};
S_vs_G_Table(6,2) = num2cell(2*sum((St-Gt).^2)/(sum(St.^2)+sum(Gt.^2)));
S_vs_G_Table(7,1) = {'C (S,G2) ='};
S_vs_G_Table(7,2) = num2cell(2*sum((St-GtFech2).^2)/(sum(St.^2)+sum(GtFech2.^2)));
S_vs_G_Table(8,:) = {'S','G1','G2'};
S_vs_G_Table(9:end,1) = num2cell(St);
S_vs_G_Table(9:end,2) = num2cell(Gt);
S_vs_G_Table(9:end,3) = num2cell(GtFech2);

% MDS
MDS_Table = {};
if flagmds == 1

    maxtotaldim = max([(dimmdsto-dimmdsfrom+1) (dimmds2to-dimmds2from+1)]);
    MDS_Table = cell((size(Gmds,1)+3)*maxtotaldim+4,2*dimmdsto+dimmds2to+5);
    MDS_Table{1,1} = 'MDS Solution : Fechnerian 1';
    MDS_Table{1,3+dimmdsto} = 'MDS Solution : Fechnerian 2';
    MDS_Table{1,end-dimmds2to} = 'MDS Solution : S-Index';
    MDS_Table{3,1} = 'Stress';
    MDS_Table{3,3+dimmdsto} = 'Stress';
    MDS_Table{3,end-dimmds2to} = 'Stress';
    nr = size(Gmds,1);
    cnt = 1;    % for Fechnerian 1 results
    for i = dimmdsfrom:dimmdsto
        MDS_Table{2,1+i} = ['Dim.' num2str(i)];
        MDS_Table{3,1+i} = stressall(i-dimmdsfrom+1);

        MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+5,1) = {['Dimension ' num2str(i)]};
        MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+6,1) = {'Pt.Id'};
        MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+7:(nr+3)*((i-dimmdsfrom+1)-1)+6+nr,1) = ptid;
        for j = 1:i
            MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+6,1+j) = {['Dim.' num2str(j)]};
            MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+7:(nr+3)*((i-dimmdsfrom+1)-1)+6+nr,1+j) = num2cell(Gmdsall(:,cnt));
            cnt = cnt+1;
        end
    end
    
    cnt = 1;    % for Fechnerian 2 results
    for i = dimmdsfrom:dimmdsto
        MDS_Table{2,3+dimmdsto+i} = ['Dim.' num2str(i)];
        MDS_Table{3,3+dimmdsto+i} = stressallFech2(i-dimmdsfrom+1);

        MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+5,3+dimmdsto) = {['Dimension ' num2str(i)]};
        MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+6,3+dimmdsto) = {'Pt.Id'};
        MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+7:(nr+3)*((i-dimmdsfrom+1)-1)+6+nr,3+dimmdsto) = ptid;
        for j = 1:i
            MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+6,3+dimmdsto+j) = {['Dim.' num2str(j)]};
            MDS_Table((nr+3)*((i-dimmdsfrom+1)-1)+7:(nr+3)*((i-dimmdsfrom+1)-1)+6+nr,3+dimmdsto+j) = num2cell(GmdsallFech2(:,cnt));
            cnt = cnt+1;
        end
    end

    cnt = 1;    % for S-index results
    for i = dimmds2from:dimmds2to
        MDS_Table{2,end-dimmds2to+i} = ['Dim.' num2str(i)];
        MDS_Table{3,end-dimmds2to+i} = stressall2(i-dimmds2from+1);

        MDS_Table((nr+3)*((i-dimmds2from+1)-1)+5,end-dimmds2to) = {['Dimension ' num2str(i)]};
        MDS_Table((nr+3)*((i-dimmds2from+1)-1)+6,end-dimmds2to) = {'Pt.Id'};
        MDS_Table((nr+3)*((i-dimmds2from+1)-1)+7:(nr+3)*((i-dimmds2from+1)-1)+6+nr,end-dimmds2to) = ptid;
        for j = 1:i
            MDS_Table((nr+3)*((i-dimmds2from+1)-1)+6,end-dimmds2to+j) = {['Dim.' num2str(j)]};
            MDS_Table((nr+3)*((i-dimmds2from+1)-1)+7:(nr+3)*((i-dimmds2from+1)-1)+6+nr,end-dimmds2to+j) = num2cell(Smdsall(:,cnt));
            cnt = cnt+1;
        end
    end

end

% KMEANS
KMEANS_Table = {};
if flagkm == 1 && flagmds == 1
    KMEANS_Table = cell(size(Idkm,1)+2,8);
    KMEANS_Table(1,[1 4 7]) = {'Fechnerian 1','Fechnerian 2','S-Index'};
    KMEANS_Table(2,[1 2 4 5 7 8]) = {'Object','Cluster Index','Object','Cluster Index','Object','Cluster Index'};
    KMEANS_Table(3:end,1) = ptid;
    KMEANS_Table(3:end,4) = ptid;
    KMEANS_Table(3:end,7) = ptid;
    KMEANS_Table(3:end,2) = num2cell(Idkm);
    KMEANS_Table(3:end,5) = num2cell(IdkmFech2);
    KMEANS_Table(3:end,8) = num2cell(Idkms);
end

% HCA
HCA_Table = {};
if flaghc == 1
    HCA_Table = cell(2*(size(Ghc,1)+4)+1,15);
    HCA_Table(1,[1 8]) = {'Fechnerian 1','S-Index'};
    HCA_Table(size(Ghc,1)+6,1) = {'Fechnerian 2'};
    HCA_Table(2,[1 2 9 10]) = {'Cophenetic Correlation Coefficient',num2str(c),'Cophenetic Correlation Coefficient',num2str(Sc)};
    HCA_Table(4,[1 2 4 9 10 12]) = {'Object','Cluster Index','Inconsistent Function','Object','Cluster Index','Inconsistent Function'};
    HCA_Table(size(Ghc,1)+9,[1 2 4]) = {'Object','Cluster Index','Inconsistent Function'};
    HCA_Table(size(Ghc,1)+7,[1 2]) = {'Cophenetic Correlation Coefficient',num2str(cFech2)};
    HCA_Table(5:size(Ghc,1)+4,2) = num2cell(Ghc);
    HCA_Table((size(Ghc,1)+10):end,2) = num2cell(GhcFech2);
    HCA_Table(5:size(Ghc,1)+4,10) = num2cell(Shc);
    HCA_Table(5:size(Ghc,1)+4-1,4:7) = num2cell(I);
    HCA_Table((size(Ghc,1)+10):end-1,4:7) = num2cell(IFech2);
    HCA_Table(5:size(Ghc,1)+4-1,12:end) = num2cell(SI);
    HCA_Table(5:size(Ghc,1)+4,1) = ptid;
    HCA_Table((size(Ghc,1)+10):end,1) = ptid;
    HCA_Table(5:size(Ghc,1)+4,9) = ptid;
end